<?php

/*  Alternate WebshopEngine
(C) 2009-2014 by Alternate Tools
-----------------------------------------------------

File:         edit_file.php
Description:  Administrative module to edit plain text files

*/

    include "../modules/mod_config.php";
    include "../modules/mod_admin.php";
    include "../modules/class_translation.php";
    include "../modules/class_textfile.php";

    $cFile = new cTextFile;
    $errorString = "";

    // Check privileges
    check_login();
    if (user_is_customer() == true)
    {
        log_out();
        return;
    }
    if (user_is_reporter() == true)
    {
        header('location: ' . $ADMIN_MAIN_SITE);
        return;
    }

    // Check filename
    $fileName = "";
    if (isset ($_POST['file_name']) == true)
        $fileName = $_POST['file_name'];
    else if (isset ($_GET['filename']) == true)
        $fileName = $_GET['filename'];
    if (file_exists($fileName) == false)
        $errorString = $cTrans->GetTranslation('admin_filedt_errorload') . ': ' . $fileName;

    // Check back to
    $backTo = "";
    if (isset ($_POST['back_to']) == true)
        $backTo = $_POST['back_to'];
    else if (isset ($_GET['backto']) == true)
        $backTo = $_GET['backto'];
        
    // Check WYSIWYG editor usage
    $useWysiwyg = false;
    if (isset ($_POST['use_wysiwyg']) == true)
        $useWysiwyg = $_POST['use_wysiwyg'];
    else if (isset ($_GET['use_wysiwyg']) == true)
        $useWysiwyg = $_GET['use_wysiwyg'];


    // File edit cancelled?
    if (isset ($_POST['file_Cancel']))
    {
        if ($backTo != "")
        {
            header ("Location: " . $backTo);
            return;
        }
        else
        {
            if ($fileName != $SHOP_CSS_FILE && $fileName != $ADMIN_CSS_FILE)
                header ('Location: ' . $ADMIN_CONFIG_SITE);
            else
                header ('Location: ' . $ADMIN_LAYOUT_SITE);
            return;
        }
    }

    // Save the file
    if (isset ($_POST['file_Save']))
    {
        if (isset($_POST['file_content']))
        {
            $_POST['file_content'] = str_replace("<textarea_begin", "<textarea", $_POST['file_content']);
            $_POST['file_content'] = str_replace("<textarea_end", "</textarea", $_POST['file_content']);
            $cFile->SaveToFile($fileName, $_POST['file_content']);
            log_message ('User ' . get_user_name() . ' saved file ' . $fileName);
            if ($backTo != "")
            {
                header ("Location: " . $backTo);
                return;
            }
            else
            {
                if ($fileName != $SHOP_CSS_FILE)
                    header ('Location: ' . $ADMIN_CONFIG_SITE);
                else
                    header ('Location: ' . $ADMIN_MAIN_SITE);
                return;
            }
        }
        else
            $errorString = 'admin_filedt_errorsave' . ': ' . $fileName;
    }

    // Display file content
    $backLink = $ADMIN_LAYOUT_SITE;
    if ($fileName != $SHOP_CSS_FILE && $fileName != $ADMIN_CSS_FILE)
        $backLink = $ADMIN_CONFIG_SITE;

    print_admin_header($cTrans->GetTranslation('admin_filedt_edithead') . ':<br>' . $fileName, true, $cTrans->GetTranslation('admin_login_logout'), true, $cTrans->GetTranslation('admin_backtomain'),
                       $backLink, $cTrans->GetTranslation('admin_config_button'), false);
    if ($useWysiwyg == true)
        print_wysiwyg_header();
    finish_admin_header($cTrans->GetTranslation('admin_filedt_edithead') . ':<br>' . $fileName, true, $cTrans->GetTranslation('admin_login_logout'), true, $cTrans->GetTranslation('admin_backtomain'),
                       $backLink, $cTrans->GetTranslation('admin_config_button'));

    if ($errorString != "")
    {
        print_error_message($errorString);
        return;
    }

    $fileContent = $cFile->LoadFromFile($fileName);
    $fileContent = str_replace("<textarea", "<textarea_begin", $fileContent);
    $fileContent = str_replace("</textarea", "<textarea_end", $fileContent);

    echo_r('<form action="' . $_SERVER['PHP_SELF'] . '" method="post" enctype="multipart/form-data">');
    echo_r('<table width="100%">');
    echo_r('<tr>');
    echo_r('  <td>');
    echo_r('    <textarea cols="100" rows="20" name="file_content" wrap="off">' . $fileContent . '</textarea>');
    echo_r('  </td>');
    echo_r('</tr>');
    echo_r('</table>');

    print_bottom_links("file_Save", $cTrans->GetTranslation('admin_save'),
                       "file_Cancel", $cTrans->GetTranslation('admin_cancel'), false);
    echo_r('<input type="hidden" name="file_name" value="' . $fileName . '">');
    echo_r('<input type="hidden" name="back_to" value="' . $backTo . '">');
    echo_r('<input type="hidden" name="use_wysiwyg" value="' . $useWysiwyg . '">');
    echo_r('</form>');

    print_admin_footer();

?>