<?php

/*  Alternate WebshopEngine
(C) 2009-2015 by Alternate Tools
-----------------------------------------------------

File:         edit_systemconfig.php
Description:  Administrative module to edit shop system configuration

*/

    include "../modules/mod_config.php";
    include "../modules/mod_admin.php";
    include "../modules/class_translation.php";
    include "../modules/class_textfile.php";

    $cTrans = new cTranslation;
    $cFile = new cTextFile;
    $cTrans->SetTranslationFile($ADMIN_LANGUAGE_FILE);
    $con_Config = new cConfiguration;
    $con_Config->SetConfigurationFile($ADMIN_CONFIG_FILE);
    $bErrorOccured = false;
    $errorString = "";

    // Check privilege
    check_login();
    if (user_is_customer() == true)
    {
        log_out();
        return;
    }
    if (user_is_admin() == false)
    {
        header('location: '. $ADMIN_CONFIG_SITE);
        return;
    }

    if ($con_Config->LoadConfigFile() == false)
        $errorString = $cTrans->GetTranslation('admin_sysed_errorload') . '!';

    // Cancel config?
    if (isset($_POST['config_Cancel']))
    {
        header('location: ' . $ADMIN_CONFIG_SITE);
        return;
    }
    
    // Save config?
    if (isset($_POST['config_Save']))
    {
        // Charset
        if (isset($_POST['conf_charset']) == false || $_POST['conf_charset'] == "")
            $_POST['conf_charset'] = "ISO-8859-1";  // default
        $con_Config->SetParameter("charset_format", $_POST['conf_charset']);
        // Meta tags
        if (isset($_POST['conf_metarevisit']) == false || $_POST['conf_metarevisit'] == "")
            $_POST['conf_metarevisit'] = "5days";  // default
        $con_Config->SetParameter("meta_revisit", $_POST['conf_metarevisit']);
        if (isset($_POST['conf_metalanguage']) == false || $_POST['conf_metalanguage'] == "")
            $_POST['conf_metalanguage'] = "EN";  // default
        $con_Config->SetParameter("meta_language", $_POST['conf_metalanguage']);
        // Email for admin
        if (isset($_POST['conf_adminemail']) && $_POST['conf_adminemail'] != "")
        {
            if (!ereg("^.+@.+\\..+$", $_POST['conf_adminemail']))
            {
                $errorString = $cTrans->GetTranslation('admin_sysed_erroradminemail') . '!';
                $bErrorOccured = true;
            }
            else
                $con_Config->SetParameter("admin_mail", $_POST['conf_adminemail']);
        }
        else
        {
            $errorString = $cTrans->GetTranslation('admin_sysed_erroradminemail') . '!';
            $bErrorOccured = true;
        }
        // Mail on order failed
        $con_Config->SetParameter("admin_mail_orderfailed", isset($_POST['conf_adminonorderfailed']));
        // Mail on backend login
        $con_Config->SetParameter("admin_mail_backendlogin", isset($_POST['conf_adminonbackendlogin']));
        // Mail on contact
        $con_Config->SetParameter("admin_mail_contact", isset($_POST['conf_adminoncontact']));
        // Mail on order done
        $con_Config->SetParameter("admin_mail_orderdone", isset($_POST['conf_adminonorderdone']));
        // Mail on auto customer email
        $con_Config->SetParameter("admin_mail_autocustemail", isset($_POST['conf_adminonautocustemail']));
        // Contact SPAM protection
        $con_Config->SetParameter("admin_mail_contactsecurity", isset($_POST['conf_mailcontactsecurity']));
        // Custom fields
        if (isset($_POST['conf_presetcustcount']) == false || $_POST['conf_presetcustcount'] == "" || is_numeric($_POST['conf_presetcustcount']) == false || $_POST['conf_presetcustcount'] < 1)
            $_POST['conf_presetcustcount'] = "8";  // default
        $con_Config->SetParameter("preset_custom_field_count", $_POST['conf_presetcustcount']);
        if (isset($_POST['conf_articlecustcount']) == false || $_POST['conf_articlecustcount'] == "" || is_numeric($_POST['conf_articlecustcount']) == false || $_POST['conf_articlecustcount'] < 1)
            $_POST['conf_articlecustcount'] = "5";  // default
        $con_Config->SetParameter("article_custom_field_count", $_POST['conf_articlecustcount']);
        // Additional articel images
        $con_Config->SetParameter("use_article_additional_images", isset($_POST['conf_additionalarticleimages']));
        if (isset($_POST['conf_additionalarticleimagescount']) == false || $_POST['conf_additionalarticleimagescount'] == "" || is_numeric($_POST['conf_additionalarticleimagescount']) == false || $_POST['conf_additionalarticleimagescount'] < 0)
            $_POST['conf_additionalarticleimagescount'] = "0";  // default
        $con_Config->SetParameter("article_additional_images_count", $_POST['conf_additionalarticleimagescount']);
        // Disable order
        $con_Config->SetParameter("disable_order", isset($_POST['conf_disableorder']));
        if (isset($_POST['conf_disableordermessage']) == false || $_POST['conf_disableordermessage'] == "")
            $_POST['conf_disableordermessage'] = "Direct order disabled. Please use the contact form.";  // default
        $con_Config->SetParameter("disable_order_message", $_POST['conf_disableordermessage']);
        // Customer login
        $con_Config->SetParameter("enable_customer_login", isset($_POST['conf_enablecustomerlogin']));
        $con_Config->SetParameter("enable_customer_registration", isset($_POST['conf_enablecustomerregistration']));
        $con_Config->SetParameter("force_customer_registration", isset($_POST['conf_forcecustomerregistration']));
        $con_Config->SetParameter("force_customer_login", isset($_POST['conf_forcecustomerlogin']));

        // No errors, save the config file
        if ($bErrorOccured == false)
        {
            if ($con_Config->SaveConfigFile() == false)
                $errorString = $cTrans->GetTranslation('admin_sysed_errorsave') . '!';
            else
            {
                // Done, now update the index.htm forward page
                $indexText = $cFile->LoadFromFile($SHOPINDEX_CONFIG_FILE);
                $indexTitle = $con_Config->GetParameter("shop_title");
                if ($con_Config->GetParameter("shop_sitetitle") != "")
                    $indexTitle = $indexTitle . ' - ' . $con_Config->GetParameter("shop_title");
                $indexText = str_replace('$$INDEX_TITLE$$', $indexTitle, $indexText);
                $indexText = str_replace('$$INDEX_DESCRIPTION$$', $con_Config->GetParameter("meta_description"), $indexText);
                $indexText = str_replace('$$INDEX_LANGUAGE$$', $con_Config->GetParameter("meta_language"), $indexText);
                $indexText = str_replace('$$INDEX_KEYWORDS$$', $con_Config->GetParameter("meta_tags"), $indexText);
                $indexText = str_replace('$$INDEX_REVISIT$$', $con_Config->GetParameter("meta_revisit"), $indexText);
                $cFile->SaveToFile($SHOPINDEX_FILE, $indexText);
                
                log_message ('User ' . get_user_name() . ' saved system-configuration');
                header('location: ' . $ADMIN_CONFIG_SITE);
                return;
            }
        }
    }

    // Display
    print_admin_header($cTrans->GetTranslation('admin_sysed_head'), true, $cTrans->GetTranslation('admin_login_logout'), true, $cTrans->GetTranslation('admin_backtomain'),
                       $ADMIN_CONFIG_SITE, $cTrans->GetTranslation('admin_config_button'));
    print_help_link($ADMIN_HELP_FILE . '#n2-1-1', $cTrans->GetTranslation('admin_help'));
    if ($errorString != "")
        print_error_message ($errorString);
        
    echo_r ('<form method="post" action="">');

    echo_r ('<table border="0" width="100%">');
    // Webshop charset format
    echo_r ('  <tr>');
    echo_r ('    <td width="30%">' . $cTrans->GetTranslation('admin_sysed_charset') . ': </td>');
    echo_r ('    <td><input type="text" size="10" name="conf_charset" value="' . $con_Config->GetParameter("charset_format") . '"></td>');
    echo_r ('  </tr>');
    // Webshop meta revisit
    echo_r ('  <tr>');
    echo_r ('    <td width="30%">' . $cTrans->GetTranslation('admin_sysed_metarevisit') . ': </td>');
    echo_r ('    <td><input type="text" size="5" name="conf_metarevisit" value="' . $con_Config->GetParameter("meta_revisit") . '"></td>');
    echo_r ('  </tr>');
    // Webshop meta language
    echo_r ('  <tr>');
    echo_r ('    <td width="30%">' . $cTrans->GetTranslation('admin_sysed_metalanguage') . ': </td>');
    echo_r ('    <td><input type="text" size="5" name="conf_metalanguage" value="' . $con_Config->GetParameter("meta_language") . '"></td>');
    echo_r ('  </tr>');
    echo_r ('</table>');
    // Admin email
    echo_r ('<hr>');
    echo_r ('<table border="0" width="100%">');
    echo_r ('  <tr>');
    echo_r ('    <td width="30%">' . $cTrans->GetTranslation('admin_sysed_adminemail') . ': </td>');
    echo_r ('    <td><input type="text" size="40" name="conf_adminemail" value="' . $con_Config->GetParameter("admin_mail") . '"></td>');
    echo_r ('  </tr>');
    // Admin email on order failed
    echo_r ('  <tr>');
    echo ('    <td width="30%"><input type="checkbox" name="conf_adminonorderfailed" value="1"');
    if ($con_Config->GetParameter("admin_mail_orderfailed") == true)
        echo (' checked');
    echo_r ('>' . $cTrans->GetTranslation('admin_sysed_adminmailonoderfailed') . '</td>');
    echo_r ('    <td></td>');
    echo_r ('  </tr>');
    // Admin email on backend login
    echo_r ('  <tr>');
    echo ('    <td width="30%"><input type="checkbox" name="conf_adminonbackendlogin" value="1"');
    if ($con_Config->GetParameter("admin_mail_backendlogin") == true)
        echo (' checked');
    echo_r ('>' . $cTrans->GetTranslation('admin_sysed_adminmailonbackendlogin') . '</td>');
    echo_r ('    <td></td>');
    echo_r ('  </tr>');
    // Admin email on contact
    echo_r ('  <tr>');
    echo ('    <td width="30%"><input type="checkbox" name="conf_adminoncontact" value="1"');
    if ($con_Config->GetParameter("admin_mail_contact") == true)
        echo (' checked');
    echo_r ('>' . $cTrans->GetTranslation('admin_sysed_adminmailoncontact') . '</td>');
    echo_r ('    <td></td>');
    echo_r ('  </tr>');
    // Admin email on order done
    echo_r ('  <tr>');
    echo ('    <td width="30%"><input type="checkbox" name="conf_adminonorderdone" value="1"');
    if ($con_Config->GetParameter("admin_mail_orderdone") == true)
        echo (' checked');
    echo_r ('>' . $cTrans->GetTranslation('admin_sysed_adminmailonoderdone') . '</td>');
    echo_r ('    <td></td>');
    echo_r ('  </tr>');
    // Admin email on auto customer emails
    echo_r ('  <tr>');
    echo ('    <td width="30%"><input type="checkbox" name="conf_adminonautocustemail" value="1"');
    if ($con_Config->GetParameter("admin_mail_autocustemail") == true)
        echo (' checked');
    echo_r ('>' . $cTrans->GetTranslation('admin_sysed_adminmailonautocustemail') . '</td>');
    echo_r ('    <td></td>');
    echo_r ('  </tr>');
    // SPAM protection
    echo_r ('  <tr>');
    echo ('    <td width="30%"><input type="checkbox" name="conf_mailcontactsecurity" value="1"');
    if ($con_Config->GetParameter("admin_mail_contactsecurity") == true)
        echo (' checked');
    echo_r ('>' . $cTrans->GetTranslation('admin_sysed_contactsecurity') . '</td>');
    echo_r ('    <td></td>');
    echo_r ('  </tr>');
    echo_r ('</table>');
    // Custom field count presets
    echo_r ('<hr>');
    echo_r ('<table border="0" width="100%">');
    echo_r ('  <tr>');
    echo_r ('    <td width="30%">' . $cTrans->GetTranslation('admin_sysed_presetcustcount') . ': </td>');
    echo_r ('    <td><input type="text" size="5" name="conf_presetcustcount" value="' . $con_Config->GetParameter("preset_custom_field_count") . '"></td>');
    echo_r ('  </tr>');
    // Custom field count articles
    echo_r ('  <tr>');
    echo_r ('    <td width="30%">' . $cTrans->GetTranslation('admin_sysed_articlecustcount') . ': </td>');
    echo_r ('    <td><input type="text" size="5" name="conf_articlecustcount" value="' . $con_Config->GetParameter("article_custom_field_count") . '"></td>');
    echo_r ('  </tr>');
    echo_r ('</table>');
    // Additional article images
    echo_r ('<hr>');
    echo_r ('<table border="0" width="100%">');
    echo_r ('  <tr>');
    echo ('    <td width="30%"><input type="checkbox" name="conf_additionalarticleimages" value="1"');
    if ($con_Config->GetParameter("use_article_additional_images") == true)
        echo (' checked');
    echo_r ('>' . $cTrans->GetTranslation('admin_sysed_additionalarticleimages') . '</td>');
    echo_r ('    <td></td>');
    echo_r ('  </tr>');
    echo_r ('  <tr>');
    echo_r ('    <td width="30%">' . $cTrans->GetTranslation('admin_sysed_additionalarticleimagescount') . ': </td>');
    echo_r ('    <td><input type="text" size="5" name="conf_additionalarticleimagescount" value="' . $con_Config->GetParameter("article_additional_images_count") . '"></td>');
    echo_r ('  </tr>');
    echo_r ('</table>');
    // Disable order
    echo_r ('<hr>');
    echo_r ('<table border="0" width="100%">');
    echo_r ('  <tr>');
    echo ('    <td width="30%"><input type="checkbox" name="conf_disableorder" value="1"');
    if ($con_Config->GetParameter("disable_order") == true)
        echo (' checked');
    echo_r ('>' . $cTrans->GetTranslation('admin_sysed_disableorder') . '</td>');
    echo_r ('    <td></td>');
    echo_r ('  </tr>');
    echo_r ('  <tr>');
    echo_r ('    <td width="30%">' . $cTrans->GetTranslation('admin_sysed_disableordermessage') . ': </td>');
    echo_r ('    <td><input type="text" size="80" name="conf_disableordermessage" value="' . $con_Config->GetParameter("disable_order_message") . '"></td>');
    echo_r ('  </tr>');
    echo_r ('</table>');
    // Customer login
    echo_r ('<hr>');
    echo_r ('<table border="0" width="100%">');
    echo_r ('  <tr>');
    echo ('    <td width="30%"><input type="checkbox" name="conf_enablecustomerlogin" value="1"');
    if ($con_Config->GetParameter("enable_customer_login") == true)
        echo (' checked');
    echo_r ('>' . $cTrans->GetTranslation('admin_sysed_enablecustomerlogin') . '</td>');
    echo_r ('    <td></td>');
    echo_r ('  </tr>');
    echo_r ('  <tr>');
    echo ('    <td width="30%"><input type="checkbox" name="conf_enablecustomerregistration" value="1"');
    if ($con_Config->GetParameter("enable_customer_registration") == true)
        echo (' checked');
    echo_r ('>' . $cTrans->GetTranslation('admin_sysed_enablecustomerregistration') . '</td>');
    echo_r ('    <td></td>');
    echo_r ('  </tr>');
    echo_r ('  <tr>');
    echo ('    <td width="30%"><input type="checkbox" name="conf_forcecustomerregistration" value="1"');
    if ($con_Config->GetParameter("force_customer_registration") == true)
        echo (' checked');
    echo_r ('>' . $cTrans->GetTranslation('admin_sysed_forcecustomerregistration') . '</td>');
    echo_r ('    <td></td>');
    echo_r ('  </tr>');
    echo_r ('  <tr>');
    echo ('    <td width="30%"><input type="checkbox" name="conf_forcecustomerlogin" value="1"');
    if ($con_Config->GetParameter("force_customer_login") == true)
        echo (' checked');
    echo_r ('>' . $cTrans->GetTranslation('admin_sysed_forcecustomerlogin') . '</td>');
    echo_r ('    <td></td>');
    echo_r ('  </tr>');
    echo_r ('</table>');

    print_bottom_links("config_Save", $cTrans->GetTranslation('admin_save'),
                       "config_Cancel", $cTrans->GetTranslation('admin_cancel'), false);
    echo_r ('</form>');

    print_admin_footer();
?>