<?php

/*  Alternate WebshopEngine
(C) 2009-2014 by Alternate Tools
-----------------------------------------------------

File:         shop_login.php
Description:  Shop Login site

*/
    include "../modules/mod_config.php";
    include "../modules/mod_shop.php";

    // Check for maintenance mode...
    if ($SHOP_MAINTENANCE_MODE == true)
    {
        include $ADMIN_MAINTENANCE_SITE;
        return;
    }

    include "../modules/class_translation.php";
    include "../modules/class_userlist.php";
    
    $errorMessage = "";
    
    // Log out?
    if (isset ($_GET['logout']) == true)
    {
        log_out();
        // Forward to main page, if login is forced, this will lead back here
        header ('location: ' . $SHOP_MAIN_SITE);
        return;
    }
    
    // Cancel login?
    if (isset ($_POST['login_Cancel']))
    {
        header ('location: ' . $SHOP_MAIN_SITE);
        return;
    }

    // Register?
    if ($ENABLE_CUSTOMER_REGISTRATION == true && isset ($_POST['login_Register']))
    {
        header ('location: ' . $SHOP_REGISTER_SITE);
        return;
    }

    // Check user authorisation?
    if (isset ($_POST['login_Do']))
    {
        $usrList = new cUserList;
        $usrList->SetFolder($CUSTOMER_FOLDER);
        $loginResult = $usrList->CheckLogin($_POST['login_username'], $_POST['login_password']);
        if ($loginResult == $USERTYPE_NONE)
        {
            $errorMessage = $cTrans->GetTranslation('shop_login_error') . '!';
            log_message ('User ' . $_POST['login_username'] . ' login failed!');
        }
        else
        {
            log_in ($_POST['login_username'], $loginResult);
            // Only customers allowed, here
            if (user_is_customer() == false)
            {
                $errorMessage = $cTrans->GetTranslation('shop_login_error') . '!';
                log_message ('User ' . $_POST['login_username'] . ' login failed!');
            }
            else
            {
                log_message ('User ' . $_POST['login_username'] . ' logged in');
                // Send email to admin?
                if ($ADMIN_MAILON_BACKENDLOGIN == true)
                    send_mail($ADMIN_EMAIL, $SHOP_TITLE . $cTrans->GetTranslation('shop_login_head'), $SHOP_TITLE . $cTrans->GetTranslation('shop_login_head') . ' -> User: ' . $_POST['login_username'], $SHOP_TITLE . '<' . $SHOP_ORDEREMAIL . '>');
                header ('location: ' . $SHOP_MAIN_SITE);
                return;
            }
        }
    }

    // Display login site
    $contPage = build_page($SHOP_THEME, false, true, true, "");
    $contPage = fill_titles($contPage, $SHOP_TITLE, $SHOP_TITLE . $cTrans->GetTranslation('shop_login_head'));

    // Error occured?
    if ($errorMessage != "")
        $contPage = build_error_message($errorMessage, $contPage);

    // Main content
    $contMain = "";
    $contMain .= echo_sr ('<br>');
    $contMain .= echo_sr ('<br>');
    $contMain .= echo_sr ('<center>');
    $contMain .= echo_sr ('<table class="login_tbl" style="width: 40%; border: 1px; border-style: solid;" cellspacing="0" cellpadding="0">');
    $contMain .= echo_sr ('<tr>');
    $contMain .= echo_sr ('  <td width="15%"></td>');
    $contMain .= echo_sr ('  <td width="70%" class="login_tbltd">');
    $contMain .= echo_sr ('    <form method="post" action=""><br><br>');
    $contMain .= echo_sr ('    <table border="0"><tr>');
    $contMain .= echo_sr ('      <td>' . $cTrans->GetTranslation('shop_login_username') . ':&nbsp;&nbsp;&nbsp;&nbsp;<br><br></td>');
    $contMain .= echo_sr ('      <td><input type="text" class="login_username" name="login_username" id="login_username"><br><br></td>');
    $contMain .= echo_sr ('      </tr><tr>');
    $contMain .= echo_sr ('      <td>' . $cTrans->GetTranslation('shop_login_password') . ':&nbsp;&nbsp;&nbsp;&nbsp;<br><br></td>');
    $contMain .= echo_sr ('      <td><input type="password" class="login_password" name="login_password"><br><br></td>');
    $contMain .= echo_sr ('      </tr></table>');
    $contMain .= ('    <center><input class="bottom_btn" type="submit" id="login_Do_btn" name="login_Do" value="' . $cTrans->GetTranslation('shop_login_login') . '">');
    if ($ENABLE_CUSTOMER_REGISTRATION == true)
        $contMain .= (' <input class="bottom_btn" type="submit" id="login_Register_btn" name="login_Register" value="' . $cTrans->GetTranslation('shop_login_register') . '">');
    $contMain .= echo_sr ('</center>');
    $contMain .= echo_sr ('  </form></td>');
    $contMain .= echo_sr ('  <td width="15%"></td>');
    $contMain .= echo_sr ('</tr>');
    $contMain .= echo_sr ('</table>');
    $contMain .= echo_sr ('</center>');
    $contMain .= echo_sr ('<script type="text/javascript" language="JavaScript">');
    $contMain .= echo_sr ('  document.getElementById(\'login_username\').focus();');
    $contMain .= echo_sr ('</script>');

    if ($FORCE_CUSTOMER_LOGIN == false)
        $contMain .= build_shop_bottom_links("login_Cancel", $cTrans->GetTranslation('shop_login_backtoshop'));

    // Additional content
    $contAdditional = "";

    // Put content together
    $contContent = build_site_content($ALIGN_TOP, $contMain, $contAdditional);
    $contPage = fill_content($contPage, $contContent, "", "");
    $contPage = fill_emptyvars($contPage);

    echo_r($contPage);

?>